% Author: U. Zölzer
%
%--------------------------------------------------------------------------
% This source code is provided without any warranties as published in 
% DASP book 3rd edition, copyright Wiley & Sons 2022, available at 
% https://mydasp.com/dasp. It may be used for educational purposes and not 
% for commercial applications without further permission.
%--------------------------------------------------------------------------
% dasp_ex1_2
% March 28, 2022, Udo Zoelzer
% Exercise for Chapter "Introduction"
clf,clear;

%% 1. Compute the DtFT of (a-d)
figure(1), freqz(1,1);title('1. (a)');print -depsc dasp_ex1_5;
figure(2), freqz([0 0 0 0 1],1);title('1. (b)');print -depsc dasp_ex1_6;
figure(3), freqz([.5 .5 0 0],1);title('1. (c)');print -depsc dasp_ex1_7;
figure(4), freqz(1,[1 -0.95]);title('1. (d)');print -depsc dasp_ex1_8;

%% 2. Using the difference equation...
a=0.93;om_0=2*pi*1/20;
num= [0  a*sin(om_0) 0];
den= [1 -2*a*cos(om_0) a^2];
% 2. (c) magnitude and phase response using freqz(num,den)
figure(5), freqz(num,den);title('2. (c)');print -depsc dasp_ex1_9;

% 2. (d) difference equation and plotting
x=zeros(1,100);
x(1)=1;

% Difference equation using filter(num,den,x)
y=filter([0 0.93*sin(2*pi*1/20)],[1 -2*0.93*cos(2*pi*1/20) 0.93^2],x);

% Difference equation using sample-by-sample computation
x1=0;y1=0;y2=0;
for n=1:length(x),
yd(n)=a*sin(om_0).*x1+2*a*cos(om_0)*y1-a*a*y2;
x1=x(n);
y2=y1;y1=yd(n);
end;

figure(6),
subplot(211),stem(0:99,y(1:100),'.','b');
xlabel('n \rightarrow');ylabel('h(n)'),
title('Impulse response h(n) - filter(num,den,x)');
subplot(212),stem(0:99,yd(1:100),'.','b');
xlabel('n \rightarrow');ylabel('h(n)'),
title('Impulse response h(n) - sample-by-sample computation');
print -depsc dasp_ex1_10