% Author: U. Zölzer
%
%--------------------------------------------------------------------------
% This source code is provided without any warranties as published in 
% DASP book 3rd edition, copyright Wiley & Sons 2022, available at 
% https://mydasp.com/dasp. It may be used for educational purposes and not 
% for commercial applications without further permission.
%--------------------------------------------------------------------------
% dasp_ex1_3_1
% March 28, 2022, Udo Zoelzer
% Exercise for Chapter "Introduction"
clf,clear;

%% 1. FIR filters with linear phase (a-d)
x=zeros(1,10);x(1)=1;            % unit pulse input
% Impulse responses
h(1:2)=0.5;                     % (a)
%h(1)=0.25;h(2)=0.5;h(3)=0.25;   % (b)
%h(1)=0.5;h(2)=-0.5;             % (c)
%h(1)=0.5;h(3)=-0.5;             % (d)
 
% % Impulse response using filter(num,den,x) and unit pulse input
y=filter(h,1,x);
figure(1), subplot(321), stem(0:length(y)-1,y,'.');
title('Impulse response');
xlabel('n \rightarrow');axis([-0.5 11 -1 1]);

[f,w] = freqz(y,1);
mag = 20*log10(abs(f));
phi=180*unwrap(angle(f))/pi;

subplot(322)
plot(w/pi,mag),grid;ylabel('Magnitude in dB');
title('Magnitude response');

subplot(324)
plot(w/pi,phi),grid;ylabel('Phase in degrees');
title('Phase response');

subplot(325)
zplane(y,1);title('Pole/zero plot');

subplot(326)
grpdelay(y,1);ylabel('Group delay in samples');
title('Group delay');

print -depsc dasp_ex1_3_1a;