% Author: U. Zölzer
%
%--------------------------------------------------------------------------
% This source code is provided without any warranties as published in 
% DASP book 3rd edition, copyright Wiley & Sons 2022, available at 
% https://mydasp.com/dasp. It may be used for educational purposes and not 
% for commercial applications without further permission.
%--------------------------------------------------------------------------
% dasp_ex1_3_2
% March 28, 2022, Udo Zoelzer
% Exercise for Chapter "Introduction"
h=0.93.^(0:100).*sin(2*pi*1/20.*(0:100));
x=zeros(1,100);
x(1)=1;
y=filter([0 0.93*sin(2*pi*1/20)],[1 -2*0.93*cos(2*pi*1/20) 0.93^2],x);

subplot(221),plot(0:99,h(1:100),'b'),
xlabel('n');ylabel('h_{IIR}(n)'),title('Infinite impulse response')
yt=y;yt(20:100)=0;
subplot(222),plot(0:99,yt(1:100),'r');
xlabel('n');ylabel('h_{FIR}(n)'),title('Finite impulse response');

[H,w]=freqz(h,1);
[Ht,w]=freqz(yt,1);
 
subplot(223),plot(w/pi,20*log10(abs(H)),w/pi,20*log10(abs(Ht)));
ylabel('Magnitude in dB');title('Magnitude response');
xlabel('Normalized frequency x rad/sample');grid;

subplot(224),plot(w/pi,180*unwrap(angle(H))/pi,w/pi,180*unwrap(angle(Ht))/pi);
ylabel('Phase in degrees');title('Phase response');
xlabel('Normalized frequency x rad/sample');grid;

print -depsc dasp_ex1_3_fir_iir