% Author: U. Zölzer
%
%--------------------------------------------------------------------------
% This source code is provided without any warranties as published in 
% DASP book 3rd edition, copyright Wiley & Sons 2022, available at 
% https://mydasp.com/dasp. It may be used for educational purposes and not 
% for commercial applications without further permission.
%--------------------------------------------------------------------------
% dasp_ex1_3_4
% March 28, 2022, Udo Zoelzer
% Exercise for Chapter "Introduction"
fc=4410;fs=44100;
a=(1-sin(2*pi*fc/fs))/cos(2*pi*fc/fs);
% Lowpass
num=(1-a)/2*[1 1];
den=[1 -a];
% % Highpass
% num=(1+a)/2*[1 -1];
% den=[1 -a];
% % Bandpass
% fb= 4410;
% a=(1-sin(2*pi*fb/fs))/cos(2*pi*fb/fs);
% b=cos(2*pi*fc/fs);
% num=(1-a)/2*[1 0 -1];
% den=[1 -b*(1+a) a];

x=zeros(1,50);
x(1)=1;

% % Impulse response using filter(num,den,x) and unit pulse input
y=filter(num,den,x);
figure(1), subplot(321), stem(0:length(y)-1,y,'.');
title('Impulse response');
xlabel('n \rightarrow');axis([-0.5 50 -1 1]);

[f,w] = freqz(num,den);
mag = 20*log10(abs(f));
phi=180*unwrap(angle(f))/pi;

subplot(322)
plot(w/pi,mag),grid;ylabel('Magnitude in dB');
title('Magnitude response');

subplot(324)
plot(w/pi,phi),grid;ylabel('Phase in degrees');
title('Phase response');

subplot(325)
zplane(num,den);title('Pole/zero plot');

subplot(326)
grpdelay(num,den);ylabel('Group delay in samples');
title('Group delay');

% print -depsc dasp_ex1_3_hp