% Author: U. Zölzer
%
%--------------------------------------------------------------------------
% This source code is provided without any warranties as published in 
% DASP book 3rd edition, copyright Wiley & Sons 2022, available at 
% https://mydasp.com/dasp. It may be used for educational purposes and not 
% for commercial applications without further permission.
%--------------------------------------------------------------------------
% dasp_ex1_4_1
% March 28, 2022, Udo Zoelzer
% Exercise for Chapter "Introduction"
clf,clear;
[X, FS] = audioread('aint-no-sunshine.wav') ;

Nx=length(X);
p=32;
mu=1.5;

x_buff=zeros(1,p); % filter input
b=zeros(1,p);      % prediction coeffs
E=zeros(1,Nx);     % predicton error
Xp=zeros(1,Nx);    % prediction output

for n=1:Nx
Xp(n) = x_buff*b';   % prediction
E(n) = X(n) - Xp(n); % prediction error
for i=1:p            % Update of coefficients with LMS
b(i) = b(i) + mu*x_buff(i)*E(n);
end
x_buff = [X(n), x_buff(1:p-1)]; %newest input sample first
end

figure(1)
subplot(311),plot(X);ylabel('x(n)');
subplot(312),plot(Xp);ylabel('x_p(n)');
subplot(313),plot(E);ylabel('e(n)');
xlabel('n \rightarrow');

% print -depsc dasp_ex1_4_lpc